/*
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2007, 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
dojo.provide("com.ibm.rdm.web.commenting.EventTopics");

// PUBLISHED EVENTS
// CommentingWidget (via CommentingController) publishes the following events
/*
   Published when the ResourceLocationPane is selected in the Commenting widget.
   [resourceLocationId, resourceUri] 
*/
com.ibm.rdm.web.commenting.EventTopics.RESOURCE_LOCATION_PANE_SELECTED_TOPIC = "rdm.annotation.100";

/*
    Published after commenting widget saves a NEW comment.
    [Comment]
*/
com.ibm.rdm.web.commenting.EventTopics.COMMENT_SAVED_TOPIC = "rdm.annotation.101";


/*
    Published after commenting widget updates an EXISTING comment.
    [Comment]
*/
com.ibm.rdm.web.commenting.EventTopics.COMMENT_UPDATED_TOPIC = "rdm.annotation.102";


/*
    Published to notify listers about the following:
    [ Object whose attrs are locationIds, and values are the no of comments in the corresponding location ]
    e.g. [ {"Label10": 12, "TextArea5": 2} ]
*/
com.ibm.rdm.web.commenting.EventTopics.LOCATE_COMMENTED_LOCATIONS_IN_RESOURCE = "rdm.annotation.103";


/*
    Signal to RCP application conatiner, annotation.html, to trigger a refresh from
    Java.
    TODO: For 6613. But this breaks the web UI refresh.
*/
com.ibm.rdm.web.commenting.EventTopics.REFRESH_COMMENTS_CLICKED = "rdm.annotation.104";
com.ibm.rdm.web.commenting.EventTopics.RESOURCE_LOCATION_PANE_HOVER_TOPIC = "rdm.annotation.105";


// SUBSCRIBED EVENTS
// CommentingWidget (via CommentingController) subscribes to the following events
/*
   Should be published by external editors when an comment has been added. Note that CommentingWidget saves
   the comment. Comment text and resource location id is available, and the the comment will be saved and displayed
   in the proper location by CommentingWidget.
*/
com.ibm.rdm.web.commenting.EventTopics.COMMENT_ADDED_TOPIC = "rdm.annotation.500";

/*
   Should be published by external editors when  
*/
// TODO: Bad name. Change to RESOURCE_LOCATION_SELECTED or something like that
com.ibm.rdm.web.commenting.EventTopics.COMMENT_SELECTED_TOPIC = "rdm.annotation.501";

/*
	Should be published by external editors when they need CommentingWidget to show a comment edit form for the provided 
	resource location id.   
*/
// TODO: This should not be an event
com.ibm.rdm.web.commenting.EventTopics.EDIT_COMMENT_FORM_FOR_LOCATION_REQUESTED_TOPIC = "rdm.annotation.502";

// TODO Bad name ... but trying to match above COMMENT_SELECTED_TOPIC for now ...
com.ibm.rdm.web.commenting.EventTopics.COMMENT_UNSELECTED_TOPIC = "rdm.annotation.503";
com.ibm.rdm.web.commenting.EventTopics.RESOURCE_LOADED_IN_VIEWER_TOPIC = "rdm.annotation.504";
com.ibm.rdm.web.commenting.EventTopics.COMMENTING_WIDGET_LOADED_TOPIC = "rdm.annotation.505";
com.ibm.rdm.web.commenting.EventTopics.REFRESH_COMMENT_TITLES_TOPIC = "rdm.annotation.506";
com.ibm.rdm.web.commenting.EventTopics.STORYBOARD_FRAME_LOADED_TOPIC = "rdm.annotation.507";

com.ibm.rdm.web.commenting.EventTopics.getTopic = function(topic, resourceURI) {
	return topic + ":" + resourceURI;
};