/*
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2007, 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
dojo.provide("com.ibm.rdm.web.common.ConfirmForm");

dojo.require("dojo.i18n");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.Button");

dojo.requireLocalization("com.ibm.rdm.web.common", "ConfirmForm");

dojo.declare("com.ibm.rdm.web.common.ConfirmForm", [dijit._Widget, dijit._Templated], {
    templatePath: dojo.moduleUrl("com.ibm.rdm.web", "common/templates/ConfirmForm.html"),
    widgetsInTemplate: true, 
    confirmMessage: null,
    dialogTitle: null,
    _dialogWidget: null,
    _confirmLabelNode: null,
    _okButtonNode: null,
    _cancelButtonNode: null,
    _messages: null,
    
    postCreate: function() {
        this.inherited("postCreate", arguments);
        this.initialize();
    },
    postMixInProperties: function() {
  	   this._messages = dojo.i18n.getLocalization("com.ibm.rdm.web.common", "ConfirmForm");
     },
    initialize: function() {  
    	var message = this.confirmMessage;
    	if (message == null) message = this._messages.confirm;
 		if (dojo.isIE) {
 			this._confirmLabelNode.innerText = message;
 		} else {
 			this._confirmLabelNode.textContent = message;
 		}
    },
    _onKeyPress: function(e) {
            var k=e.keyCode,ks=dojo.keys;
            if (k==ks.ESCAPE) {
                dojo.stopEvent(e);
                this._cancel();
            }
            if (k==ks.ENTER) {
            	dojo.stopEvent(e);
            	this._ok();
            	return;
            }
    },
    _onOk: function(e) {
        dojo.stopEvent(e);
        this._ok();        
    },
    _onCancel: function(event) {
        dojo.stopEvent(event);
        this._cancel();
    },    
    _ok: function() {
    	this._dialogWidget.hide();
    	this.destroy();
    	this._dialogWidget.destroy();
    },
    _cancel: function() {
    	this._dialogWidget.hide();
    	this.destroy();
    	this._dialogWidget.destroy();
    },
    setDialogWidget: function(dialogWidget) {
    	this._dialogWidget = dialogWidget;
    	if (this.dialogTitle == null) {
    		this.dialogTitle = this._messages.confirmTitle;
    	}
   	 	dojo.isIE?(this._dialogWidget.titleNode.innerText = this.dialogTitle):(this._dialogWidget.titleNode.textContent = this.dialogTitle);
    },
    show: function() {
    	this._okButtonNode.focus();
    	this._dialogWidget.show();
    }
});
