/*
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function(){
dojo.provide("com.ibm.rdm.web.common.DateTimeHelper");

/**
	Should be used for helper methods assosiated with Date and Time 
 */
com.ibm.rdm.web.common.DateTimeHelper = {

	DATE_RANGE_TYPE: {
		Today: "Today",
		Yesterday: "Yesterday",
		PastWeek: "Past Week",
		PastMonth: "Past Month",
		Earlier: "Earlier"
	},

	getDateRange: function(updatedDate, /*Date?*/todayDate) {
		// summary: Given updated date and optional today date object
		// 		this method will return date range for when the artifact
		// 		was updated
		//		Date ranges are Today, Yesterday, Past Week, and Earlier
		//		Use constants that are returned by this method instead of
		//		literal string when comparing date ranges
		if (!todayDate) {
			var now = new Date();
			var todayDate = new Date(now.getFullYear(), now.getMonth(), now.getDate());
		}
		
		if (updatedDate.getTime() > todayDate.getTime()) {
			return this.DATE_RANGE_TYPE.Today;
		} else if (updatedDate.getTime() > (todayDate.getTime() - 1000*60*60*24)) {
			return this.DATE_RANGE_TYPE.Yesterday;
		} else if (Math.abs(dojo.date.difference(todayDate, updatedDate, "day")) < 7) {
			return this.DATE_RANGE_TYPE.PastWeek;
		} else if ((Math.abs(dojo.date.difference(todayDate, updatedDate, "day")) < 30)) {
			return this.DATE_RANGE_TYPE.PastMonth;
		} else {
			return this.DATE_RANGE_TYPE.Earlier;
		}
	}
}

})();
