/*
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2007, 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/*
 * Provides static wrapper methods for the error reporting widgets
 */
dojo.provide("com.ibm.rdm.web.common.ErrorHandler");
com.ibm.rdm.web.common.ErrorHandler = {
    getErrorSectionWidget: function() {
		return dijit.byId("com-ibm-rdm-web-common-ErrorSectionWidget");
	},
	clearErrorSection: function() {
		try {
			getErrorSectionWidget().clearError();
		}
		catch(e){}
	},
	
	
	/*
	 * Wrapper Functions for Firebug Console API
	 * Firebug adds a global variable named "console" to all web pages loaded in Firefox. 
	 * This object contains many methods that allow you to write to the Firebug console to 
	 * expose information that is flowing through your scripts.
	 * 
	 * http://getfirebug.com/console.html
	 */
	log: function(message) {
		if (djConfig.isDebug) {
			console.log(message);
		}
	},
	info: function(message) {
		if (djConfig.isDebug) {
			console.info(message);
		}
	},
	warn: function(message) {
		if (djConfig.isDebug) {
			console.warn(message);
		}
	},
	debug: function(message) {
		if (djConfig.isDebug) {
			console.debug(message);
		}
	},
	error: function(message) {
		console.error(message);
	}
};
