/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.common.ExtendedResourceParser");
dojo.require("com.ibm.rdm.web.search.results.ResourceInfo");
dojo.require("com.ibm.rdm.web.server.XhrUtils");

var XhrUtils = com.ibm.rdm.web.server.XhrUtils;

dojo.declare(
	"com.ibm.rdm.web.common.ExtendedResourceParser",
	null,
{
	updateContext: null,

    ///////////////////////////////////////////////////////////////////////////////////
    // Private fields
	//_mapResourceURIToCacheEntry: [],
	_resourceInfo: null,
	_etag: null,
	
    ///////////////////////////////////////////////////////////////////////////////////
    // API
	getETag: function() {
		return this._etag;
	},
		
	getPropertyInfo: function() {
		return this._resourceInfo;
	},
	
	parseResponse: function(response) {
		var doc = response.doc;
		this._etag = XhrUtils.getResponseEtag(response);
		var resourceInfo = new com.ibm.rdm.web.search.results.ResourceInfo({
            atomEntryNode: doc,
            isXQuery: false,
            isExtendedResource: true
        });
		this._resourceInfo = resourceInfo;
	}

});

})();
