/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.common.PrivateTagsParser");
dojo.require("com.ibm.rdm.web.util.domutils");
dojo.require("com.ibm.rdm.web.common.UriHelper");
dojo.require("com.ibm.rdm.web.server.XhrUtils");

var XhrUtils = com.ibm.rdm.web.server.XhrUtils;
var domutils = com.ibm.rdm.web.util.domutils;
var queryutils = com.ibm.rdm.web.util.queryutils;
var UriHelper = com.ibm.rdm.web.common.UriHelper;

var PRIVATE = "private";

dojo.declare(
	"com.ibm.rdm.web.common.PrivateTagsParser",
	null,
{

	updateContext: null,
		
    ///////////////////////////////////////////////////////////////////////////////////
    // Private fields
	_tags: null,
	
    // _etag: etag for the resource that is being parsed
	_etag: null,
	
    ///////////////////////////////////////////////////////////////////////////////////
    // API
	getETag: function() {
		return this._etag;
	},
		
	getPropertyInfo: function() {
		// summary:
		//    Returns parsed response which is a map of Project URIs to 
		//    project collection URIs
		return this._tags;
	},
	
	parseResponse: function(response) {
		var doc = response.doc;
		this._tags = [];
		this._etag = XhrUtils.getResponseEtag(response);
		var entries = doc.getElementsByTagName("entry");
		for (var i = 0; i < entries.length; i++) {
			var tagObj = queryutils.getTagObject(entries[i]);
			tagObj.scope = PRIVATE;
			this._tags.push(tagObj);
			this._tags[tagObj.resourceURI] = tagObj;
		}
		return response;
	}

});



})();
