/*
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2007, 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
dojo.provide("com.ibm.rdm.web.common.UsersSelectWidget");
dojo.require("com.ibm.rdm.web.common.IconSelectWidget");
dojo.require("com.ibm.rdm.web.common.ProjectCache");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.rdm.web.common", "common");

com.ibm.rdm.web.common.UsersSelectWidgetUNSPECIFIED = "UnspecifiedUsersSelectValue";

dojo.declare("com.ibm.rdm.web.common.UsersSelectWidget", [com.ibm.rdm.web.common.IconSelectWidget], {
    UNSPECIFIED: com.ibm.rdm.web.common.UsersSelectWidgetUNSPECIFIED,
    // templateString: "<span dojoAttachPoint=\"_usersSelectNode\"  />",
    projectURI: null,
    selectValue: null,
    _messages: null,
    /*
       Boolean. If set to true, unspecified option is given the text All and class is set to "filter-form-defaults"
    */
    forFilter: null,
    postCreate: function() {
		this._messages = dojo.i18n.getLocalization("com.ibm.rdm.web.common", "common");
		if (this.projectURI) {
			var deferred = com.ibm.rdm.web.common.ProjectCache.getProjectUsers(this.projectURI);
			deferred.addCallback(this, this._populateUsersSelect);	
		} else {
			com.ibm.rdm.web.common.ProjectCache.getAllUsers().addCallback(this, this._populateUsersSelect);
		}
        //return deferred;
    },
    _populateUsersSelectWhenError: function(response) {
            var iconUri = null; // dojo.moduleUrl("com.ibm.rdm.web.common", "images/icon-team-members.gif").uri;
            var iconSelectOptions = {};
            iconSelectOptions[this.UNSPECIFIED] = {text:this._messages.noUsersFound, iconUri: iconUri};
            this.initialize(iconSelectOptions); 
            return response;
    },
    _populateUsersSelect: function(usersDoc) {
/*            var entries = usersDoc.getElementsByTagName("entry");
            // Add a default Unspecified entry
            var iconSelectOptions = {};
            var iconUri = null; //dojo.moduleUrl("com.ibm.rdm.web.common", "images/icon-team-members.gif").uri;
            if (!this.forFilter) {
                iconSelectOptions[this.UNSPECIFIED] = {text:"", iconUri: iconUri};
            }
            else {
                iconSelectOptions[this.UNSPECIFIED] = {text:"Any", iconUri: iconUri, optionClass: "filter-form-defaults" };
            }
            for (var i = 0; i < entries.length; i++) {
                var entry = entries[i];
                var username = entry.getElementsByTagName("title")[0].childNodes[0].nodeValue;
                var userid = entry.getElementsByTagName("id")[0].childNodes[0].nodeValue;
                iconSelectOptions[userid] = {text: username, iconUri: iconUri};  
            }
            this.initialize(iconSelectOptions);
            this.select(this.UNSPECIFIED);
            return usersDoc;*/
    	var iconSelectOptions = {};
    	var iconUri = null;
    	if (!this.forFilter) {
            iconSelectOptions[this.UNSPECIFIED] = {text:"", iconUri: iconUri};
        }
        else {
            iconSelectOptions[this.UNSPECIFIED] = {text:this._messages.any, iconUri: iconUri, optionClass: "filter-form-defaults" };
        }
         var sortableArray = [];
         for (var userURL in usersDoc) {
         	sortableArray.push([usersDoc[userURL].name, usersDoc[userURL].userId]);
         	sortableArray.sort(_compareName);  
        }
        for (i=0; i<sortableArray.length; i++)
        {
        	 var user = sortableArray[i]; 
             iconSelectOptions[user[1]] = {text: user[0], iconUri: iconUri};  
        }
        this.initialize(iconSelectOptions);
    	if (this.selectValue != null) {
    		if (this.iconSelectOptions[this.selectValue] == undefined) {
    			this.select(this.UNSPECIFIED);
    		} else {
    			this.select(this.selectValue);
    		}	
    	} else {
    		this.select(this.UNSPECIFIED);
    	}
    	
    	return usersDoc;
    }
    
});

	_compareName = function(array1, array2) {
		var name1 = array1[0];
		var name2 = array2[0];
		return ((name1 < name2) ? -1 : 1);
};
