/*
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
dojo.provide("com.ibm.rdm.web.links.FilterCheckedMenuItem");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dijit._base");
dojo.require("dijit.Menu");


dojo.declare(
    "com.ibm.rdm.web.links.FilterCheckedMenuItem",
    dijit.CheckedMenuItem,
{
    	// provide a template string that supports icons for the menu items
    	templateString:
   		 '<tr class="dijitReset dijitMenuItem" dojoAttachPoint="focusNode" waiRole="menuitemcheckbox" tabIndex="-1"'
   		+'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick">'
   		+'<td class="dijitReset" waiRole="presentation"><div class="dijitCheckedMenuItemIcon" dojoAttachPoint="iconNode">'
   		+'<div class="dijitCheckedMenuItemIconChar">&#10003;</div>'
   		+'</div></td>'
   		+'<td class="dijitReset dijitUserIcon" dojoAttachPoint="userIconNode">'
   		+'<div class="dijitLinksMenuItemIcon" style="background-image: url(${iconURL})"></div>'
   		+'</td>'
   		+'<td class="dijitReset dijitMenuItemLabel" dojoAttachPoint="containerNode,labelNode"></td>'
   		+'<td class="dijitReset dijitMenuArrowCell" waiRole="presentation">'
   			+'<div dojoAttachPoint="arrowWrapper" style="display: none">'
   				+'<div class="dijitMenuExpand"></div>'
   				+'<span class="dijitMenuExpandA11y">+</span>'
   			+'</div>'
   		+'</td>'
   		+'</tr>',

   	///////////////////////////////////////////////////////////////////////////////////
    // Public fields
    
    iconURL: null,
    type: null,
    
    ///////////////////////////////////////////////////////////////////////////////////
    // Private fields

    ///////////////////////////////////////////////////////////////////////////////////
    // API
    	
    _onClick: function(evt){
    	// Override so that click does not dismiss the menu
		if(!this.disabled){
			this.attr("checked", !this.checked);
			this.onChange(this.checked);
		}
	}

});
