/*
 * Copyright (c) 2007, 2008. IBM Corporation
 * All rights reserved.
 */
(function(){
dojo.provide ("com.ibm.rdm.web.links.TreeLayout");
dojo.require ("com.ibm.rdm.web.links.Tree");

/* Default values  */
RO_TOP             = 0;
RO_BOTTOM          = 1;
RO_RIGHT           = 2;
RO_LEFT            = 3;
NJ_TOP             = 0;
NJ_CENTER          = 1;
NJ_BOTTOM          = 2;
canvasoffsetTop    = 49;
canvasoffsetLeft   = 8;
maxLevelHeight     = [];
maxLevelWidth      = [];
previousLevelNode  = [];
rootYOffset        = 0;
rootXOffset        = 0;
iMaxDepth          = 100;
iLevelSeparation   = 20;
iSiblingSeparation = 20;
iSubtreeSeparation = 20;
iRootOrientation   = RO_LEFT;
iNodeJustification = NJ_TOP;
topXAdjustment     = 0;
topYAdjustment     = 0;
defaultNodeWidth   = 100;
defaultNodeHeight  = 40;


com.ibm.rdm.web.links.TreeLayout.WalkerLayout = function(){

  this.RO_TOP             = RO_TOP;
  this.RO_BOTTOM          = RO_BOTTOM;
  this.RO_RIGHT           = RO_RIGHT;
  this.RO_LEFT            = RO_LEFT;
  this.NJ_TOP             = NJ_TOP;
  this.NJ_CENTER          = NJ_CENTER;
  this.NJ_BOTTOM          = NJ_BOTTOM;
  this.canvasoffsetTop    = canvasoffsetTop;
  this.canvasoffsetLeft   = canvasoffsetLeft;
  this.maxLevelHeight     = maxLevelHeight;
  this.maxLevelWidth      = maxLevelWidth;
  this.previousLevelNode  = previousLevelNode;
  this.rootYOffset        = rootYOffset;
  this.rootXOffset        = rootXOffset;
  this.iMaxDepth          = iMaxDepth;
  this.iLevelSeparation   = iLevelSeparation;
  this.iSiblingSeparation = iSiblingSeparation;
  this.iSubtreeSeparation = iSubtreeSeparation;
  this.iRootOrientation   = this.RO_LEFT;
  this.iNodeJustification = this.NJ_TOP;
  this.topXAdjustment     = topXAdjustment;
  this.topYAdjustment     = topYAdjustment;
  this.defaultNodeWidth   = defaultNodeWidth;
  this.defaultNodeHeight  = defaultNodeHeight;
  this.rootNode = null;
  this.XMax = 0;
  this.YMax = 0;

}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype.getRootNode = function(){
   return this.rootNode;
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._treePosition = function(){
    this.maxLevelHeight = [];
    this.maxLevelWidth = [];
    this.previousLevelNode = [];
    placeHolderNode = new com.ibm.rdm.web.links.Tree.TreeNode("ROOTNODE");
    placeHolderNode.children = new Array(this.rootNode);

    this._firstWalk(placeHolderNode, 0);

    switch (this.iRootOrientation) {
           case this.RO_TOP:
           case this.RO_LEFT:
                this.rootXOffset = this.topXAdjustment + placeHolderNode.XPosition;
                this.rootYOffset = this.topYAdjustment + placeHolderNode.YPosition;
                break;
           case RO_BOTTOM:
           case RO_RIGHT:
                this.rootXOffset = this.topXAdjustment + placeHolderNode.XPosition;
                this.rootYOffset = this.topYAdjustment + placeHolderNode.YPosition;
    }
    this._secondWalk(placeHolderNode, 0, 0, 0);
}
com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._firstWalk = function(node, level){
    var leftSibling = null;
    node.XPosition = 0;
    node.YPosition = 0;
    node.prelim = 0;
    node.modifier = 0;
    this._setLevelHeight(node, level);
    this._setLevelWidth(node, level);

    if (this._getChildrenCount(node) == 0 || level == this.iMaxDepth) {
        leftSibling = this._getLeftSibling(node);
        if (leftSibling != null)
            node.prelim = leftSibling.prelim
                                   + this._getNodeSize(leftSibling) + this.iSiblingSeparation;
        else
            node.prelim = 0;
    }
    else {

        var n = this._getChildrenCount(node);
        for (var i = 0; i < n; i++) {
            var iChild = this._getChildAt(node, i);
            this._firstWalk(iChild, level + 1);
        }
        var midPoint = this._getChildrenCenter(node);
        midPoint -= this._getNodeSize(node) / 2;
        leftSibling = this._getLeftSibling(node);
        sibling = (this._getLeftSibling(node) != null)?this._getLeftSibling(node).id:null;

        if (leftSibling != null) {
            node.prelim = leftSibling.prelim
                                   + this._getNodeSize(leftSibling) + this.iSiblingSeparation;
            node.modifier = node.prelim - midPoint;
            this._apportion(node, level);
        }
        else
       node.prelim = midPoint;
   }
}
com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._apportion = function(node, level){
    var firstChild = this._getFirstChild(node);
    var firstChildLeftNeighbor = firstChild.leftNeighbor;

    var j = 1;
    for (var k = this.iMaxDepth - level; firstChild != null && firstChildLeftNeighbor != null && j <= k;) {

        var modifierSumRight = 0;
        var modifierSumLeft = 0;
        var rightAncestor = firstChild;
        var leftAncestor = firstChildLeftNeighbor;
        for (var l = 0; l < j; l++) {
            rightAncestor = rightAncestor.parent;
            leftAncestor = leftAncestor.parent;
            modifierSumRight += rightAncestor.modifier;
            modifierSumLeft += leftAncestor.modifier;
        }

        var totalGap = (firstChildLeftNeighbor.prelim + modifierSumLeft
                                            + this._getNodeSize(firstChildLeftNeighbor)
                                            + this.iSubtreeSeparation) - (firstChild.prelim
                                            + modifierSumRight);
        if (totalGap > 0) {
            var subtreeAux = node;
            var numSubtrees = 0;
            for (; subtreeAux != null && subtreeAux != leftAncestor; subtreeAux = this._getLeftSibling(subtreeAux))
                numSubtrees++;

            if (subtreeAux != null) {
                var subtreeMoveAux = node;
                var singleGap = totalGap / numSubtrees;
                for (; subtreeMoveAux != leftAncestor; subtreeMoveAux = this._getLeftSibling(subtreeMoveAux)) {
                    subtreeMoveAux.prelim += totalGap;
                    subtreeMoveAux.modifier += totalGap;
                    totalGap -= singleGap;
                }
            }
        }
        j++;
        if (this._getChildrenCount(firstChild) == 0)
            firstChild = this._getLeftmost(node, 0, j);
        else
            firstChild = this._getFirstChild(firstChild);
        if (firstChild != null)
            firstChildLeftNeighbor = firstChild.leftNeighbor;
    }
}
com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._secondWalk = function(node, level, X, Y){
    if (level <= this.iMaxDepth) {
        var xTmp = rootXOffset + node.prelim + X;
        var yTmp = rootYOffset + Y;
        var maxsizeTmp = 0;
        var nodesizeTmp = 0;
        var flag = false;

        switch (this.iRootOrientation) {
            case this.RO_TOP:
            case this.RO_BOTTOM:
                maxsizeTmp = this.maxLevelHeight[level];
                nodesizeTmp = node.h;
                break;
            case RO_RIGHT:
            case RO_LEFT:
                maxsizeTmp = this.maxLevelWidth[level];
                flag = true;
                nodesizeTmp = node.w;
                break;
        }
        switch (this.iNodeJustification) {
            case this.NJ_TOP:
                node.XPosition = xTmp;
                node.YPosition = yTmp;
                break;
            case this.NJ_CENTER:
                node.XPosition = xTmp;
                node.YPosition = yTmp + (maxsizeTmp - nodesizeTmp) / 2;
                break;
            case this.NJ_BOTTOM:
                node.XPosition = xTmp;
                node.YPosition = (yTmp + maxsizeTmp) - nodesizeTmp;
                break;
        }
        if (flag) {
            var swapTmp = node.XPosition;
            node.XPosition = node.YPosition;
            node.YPosition = swapTmp;
        }
        switch (this.iRootOrientation) {
            case this.RO_BOTTOM:
                node.YPosition = -node.YPosition - nodesizeTmp;
                break;
            case this.RO_RIGHT:
                node.XPosition = -node.XPosition - nodesizeTmp;
                break;
        }

        if (this._getChildrenCount(node) != 0)
            this._secondWalk(this._getFirstChild(node), level + 1, X + node.modifier, Y
                                                    + maxsizeTmp + this.iLevelSeparation);
        /* Keep track of the Maximum XPosition and YPosition */
        if (this.XMax < node.XPosition)
        	this.XMax = node.XPosition;
		if (this.YMax < node.YPosition)
			this.YMax = node.YPosition;
		
        var rightSibling = this._getRightSibling(node);
        if (rightSibling != null)
            this._secondWalk(rightSibling, level, X, Y);
    }
}

/* Tree Utility access methods */
com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._getNodeSize = function(node){
    switch (this.iRootOrientation) {
        case this.RO_TOP:
        case this.RO_BOTTOM:
            return node.w;

        case this.RO_RIGHT:
        case this.RO_LEFT:
            return node.h;
    }
    return 0;
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._getChildrenCount = function(node){
    if (node.isCollapsed)
        return 0;
    if (node.children == null)
        return 0;
    else
        return node.children.length;
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._getChildAt = function(node, i){
    if (node.children.length > 0)
        return node.children[i];
    else
        return node;
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._getChildrenCenter = function(node){
    node1 = this._getFirstChild(node);
    node2 = this._getLastChild(node);
    return node1.prelim + ((node2.prelim - node1.prelim) + this._getNodeSize(node2)) / 2;
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._getFirstChild = function(node){
    return this._getChildAt(node, 0);
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._getLastChild = function(node){
    var index = this._getChildrenCount(node) - 1;
    return this._getChildAt(node, this._getChildrenCount(node) - 1);
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._getLeftSibling = function(node){
    if (node.leftNeighbor != null && node.leftNeighbor.parent == node.parent)
        return node.leftNeighbor;
    else
        return null;
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._getLeftmost = function(node, level, maxlevel){
    if (level >= maxlevel)
        return node;
    if (this._getChildrenCount(node) == 0)
        return null;
    var n = this._getChildrenCount(node);
    for (var i = 0; i < n; i++) {
        var iChild = this._getChildAt(node, i);
        var leftmostDescendant = this._getLeftmost(iChild, level + 1, maxlevel);
        if (leftmostDescendant != null)
            return leftmostDescendant;
    }
    return null;
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._getRightSibling = function(node){
    if (node.rightNeighbor != null && node.rightNeighbor.parent == node.parent)
        return node.rightNeighbor;
    else
        return null;
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._setLevelHeight = function(node, level){
    if (this.maxLevelHeight[level] == null)
        this.maxLevelHeight[level] = 0;
    if (this.maxLevelHeight[level] < node.h)
        this.maxLevelHeight[level] = node.h;
}

com.ibm.rdm.web.links.TreeLayout.WalkerLayout.prototype._setLevelWidth = function(node, level){
    if (this.maxLevelWidth[level] == null)
        this.maxLevelWidth[level] = 0;
    if (this.maxLevelWidth[level] < node.w)
        this.maxLevelWidth[level] = node.w;
}


})();
