/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.search.DocumentTypes");

dojo.require("com.ibm.rdm.web.common.MimeTypes");
dojo.require("com.ibm.rdm.web.search.searchutils");
dojo.require("com.ibm.rdm.web.search.DocumentTypeParser");
dojo.require("com.ibm.rdm.web.search.IndexRuleParser");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.rdm.web.search", "DocumentTypes");


// TODO Don't hard code doc type info ... glean this from the server instead.
dojo.declare(
    "com.ibm.rdm.web.search.DocumentTypes",
    null,
    {
        ///////////////////////////////////////////////////////////////////////////////////
        // Public fields

        searchQuery: null,

        ///////////////////////////////////////////////////////////////////////////////////
        // Private fields

        // E.g. ["http://com.ibm.rdm/FEAT", "http://com.ibm.rdm/SUPP", ...]
        _doctypeNamespaces: null,
        // E.g. this._mapDoctypesShortnamesToMimeTypes["FEAT"] = com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQ_DOCTYPE
        _mapDoctypesShortnamesToMimeTypes: null,
// TODO Remove this at some point ... but here's what we used when things were hardcoded ...
//         _doctypeNamespaces: [
//             "http://com.ibm.rdm/FEAT",
//             "http://com.ibm.rdm/SUPP",
//             "http://com.ibm.rdm/UC",
//             "http://com.ibm.rdm/REQPRO"
//         ],
        _attributeValueData: new Object,
        _messages: null,

        ///////////////////////////////////////////////////////////////////////////////////
        // API

	    constructor: function(/* Object */ keywordParameters) {
// TODO Remove this at some point ... but here's what we used when things were hardcoded ...
//             this._attributeValueData["FEAT"] = [
//                 {
//                     attributeName: "Type",
//                     attributeField: "http://com.ibm.rdm/FEAT%23Type",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "Functional", "Non-functional" ]
//                 },
//                 {
//                     attributeName: "Priority",
//                     attributeField: "http://com.ibm.rdm/FEAT%23Priority",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "Must", "Should", "Could", "Won't" ]
//                 },
//                 {
//                     attributeName: "Status",
//                     attributeField: "http://com.ibm.rdm/FEAT%23Status",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "Proposed", "Approved", "Incorporated", "Validated" ]
//                 },
//                 {
//                     attributeName: "Difficulty",
//                     attributeField: "http://com.ibm.rdm/FEAT%23Difficulty",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "High", "Medium", "Low" ]
//                 },
//                 {
//                     attributeName: "Stability",
//                     attributeField: "http://com.ibm.rdm/FEAT%23Stability",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "High", "Medium", "Low" ]
//                 },
//                 {
//                     attributeName: "Origin",
//                     attributeField: "http://com.ibm.rdm/FEAT%23Origin",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "Help Desk", "Partners", "Competitors", "Customer Visits" ]
//                 },
//                 {
//                     attributeName: "Contact",
//                     attributeField: "http://com.ibm.rdm/FEAT%23Contact",
//                     attributeType: "string"
//                 }
//             ];
//             this._attributeValueData["SUPP"] = [
//                 {
//                     attributeName: "Priority",
//                     attributeField: "http://com.ibm.rdm/SUPP%23Priority",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "Must", "Should", "Could", "Won't" ]
//                 },
//                 {
//                     attributeName: "Status",
//                     attributeField: "http://com.ibm.rdm/SUPP%23Status",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "Proposed", "Approved", "Incorporated", "Validated" ]
//                 },
//                 {
//                     attributeName: "Difficulty",
//                     attributeField: "http://com.ibm.rdm/SUPP%23Difficulty",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "High", "Medium", "Low" ]
//                 },
//                 {
//                     attributeName: "Stability",
//                     attributeField: "http://com.ibm.rdm/SUPP%23Stability",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "High", "Medium", "Low" ]
//                 },
//                 {
//                     attributeName: "Contact",
//                     attributeField: "http://com.ibm.rdm/SUPP%23Contact",
//                     attributeType: "string"
//                 }
//             ];
//             this._attributeValueData["UC"] = [
//                 {
//                     attributeName: "Property",
//                     attributeField: "http://com.ibm.rdm/UC%23Property",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "Name", "Brief Description", "Basic Flow", "Alternative Flow",
//                         "Special Requirements", "Pre-Conditions", "Post Conditions", "Extension Points" ]
//                 },
//                 {
//                     attributeName: "AffectsArchitecture",
//                     attributeField: "http://com.ibm.rdm/UC%23AffectsArchitecture",
//                     attributeType: "boolean"
//                 },
//                 {
//                     attributeName: "Priority",
//                     attributeField: "http://com.ibm.rdm/UC%23Priority",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "Must", "Should", "Could", "Won't" ]
//                 },
//                 {
//                     attributeName: "Status",
//                     attributeField: "http://com.ibm.rdm/UC%23Status",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "Proposed", "Approved", "Incorporated", "Validated" ]
//                 },
//                 {
//                     attributeName: "Difficulty",
//                     attributeField: "http://com.ibm.rdm/UC%23Difficulty",
//                     attributeType: "enum",
//                     attributeEnumValues: [ "High", "Medium", "Low" ]
//                 },
//                 {
//                     attributeName: "Contact",
//                     attributeField: "http://com.ibm.rdm/UC%23Contact",
//                     attributeType: "string"
//                 }
//             ];
//             this._attributeValueData["REQPRO"] = [
//                 {
//                     attributeName: "ComposerLink",
//                     attributeField: "http://com.ibm.rdm/REQPRO%23ComposerLink",
//                     attributeType: "string"
//                 },
//                 // TODO The index rules do currently do not index on ComposerRevision -- why not?
//                 {
//                     attributeName: "ComposerRevision",
//                     attributeField: "http://com.ibm.rdm/REQPRO%23ComposerRevision",
//                     attributeType: "integer"
//                 }
//             ];
            dojo.mixin(this, keywordParameters);
            this._doctypeNamespaces = [];
            this._mapDoctypesShortnamesToMimeTypes = new Object;
            // TODO Adopt changes needed to reflect M6 attr group styles ... commenting out for now ...
//             this._queryForDocTypes();
        },

        isDocTypeProperty: function(propertyName) {
            for (var i = 0; i < this._doctypeNamespaces.length; i++) {
                var docType = this._doctypeNamespaces[i];
                if (propertyName.indexOf(docType) == 0) {
                    return true;
                }
            }
            return false;
        },

        getAttributeValueProperties: function() {
            return this._attributeValueData;
        },

        getDocTypeNames: function() {
            return dojo.map(
                this._doctypeNamespaces,
                function(namespace) { return namespace.substring(namespace.lastIndexOf("/")+1); }
            );
        },

        // TODO Remove after adopting M5 attr groups
        isRequirementDocType: function(doctypeShortname) {
            return (this._mapDoctypesShortnamesToMimeTypes[doctypeShortname]
                == com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQ_DOCTYPE);
        },

        ///////////////////////////////////////////////////////////////////////////////////
        // Helpers

        _queryForDocTypes: function() {
            com.ibm.rdm.web.search.searchutils.showAsBusy(true);
            var queryParams = (
                "resource-uri=*&resource-content-type="
                + com.ibm.rdm.web.search.searchutils.encodeContentType(
                    // Note: We wish to get all resources that use either of the following
                    // MIME types:
                    //   application/x-com.ibm.rdm.doctype+xml
                    //   application/x-com.ibm.rdm.doctype.requirement+xml
                    // This is why we don't issue two separate queries for MIME-types:
                    //   com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_DOCTYPE
                    //   com.ibm.rdm.web.common.MimeTypes.CONTENT_TYPE_REQ_DOCTYPE
                    // and instead use a single wildcarded query ...
                    "application/x-com.ibm.rdm.doctype*"
                    )
            );
        },

        _getMessages: function() {
            if (!this._messages) {
                this._messages = dojo.i18n.getLocalization("com.ibm.rdm.web.search", "DocumentTypes");
            }
            return this._messages;
        },

        _handleQueryForDocTypesSuccessResponse: function(response) {
            com.ibm.rdm.web.search.searchutils.showAsBusy(false);
            var entries = response.getElementsByTagName("entry");
            for (var i = 0; i < entries.length; i++) {
                var entry = entries[i];
                var contentNode = entry.getElementsByTagName("content")[0];
                var resourceURI = contentNode.getAttribute("src");
                var type = contentNode.getAttribute("type");
                var doctypeShortName = com.ibm.rdm.web.util.queryutils.getLastPathSegment(resourceURI);
                this._mapDoctypesShortnamesToMimeTypes[doctypeShortName] = type;
                this._requestDocTypeContents(resourceURI);
            }
        },

        _handleQueryForDocTypesErrorResponse: function(error) {
            com.ibm.rdm.web.search.searchutils.showAsBusy(false);
            var messages = this._getMessages();
            com.ibm.rdm.web.search.searchutils.reportError(
                  dojo.string.substitute(messages.errorAttemptingToRetrieveDocTypeInfo,
                      { error: (error.description || error) })
            );
        },

        _requestDocTypeContents: function(resourceURI) {
            com.ibm.rdm.web.search.searchutils.showAsBusy(true);
        },

        _handleGetDocTypeSuccessResponse: function(response) {
            com.ibm.rdm.web.search.searchutils.showAsBusy(false);
            var doctype = new com.ibm.rdm.web.search.DocumentTypeParser({doc:response});
            var namespace = doctype.getDocTypeNamespace();
            var fieldProps = doctype.getDocTypeFieldProperties();
            var fieldPropArray = [];
            for (var fieldProp in fieldProps) {
                fieldPropArray.push(fieldProps[fieldProp]);
            }
            this._doctypeNamespaces.push(namespace);
            this._attributeValueData[doctype.getDocTypeName()] = fieldPropArray;
            this._requestIndexRuleContents(namespace);
        },

        _handleGetDocTypeErrorResponse: function(error) {
            com.ibm.rdm.web.search.searchutils.showAsBusy(false);
            var messages = this._getMessages();
            com.ibm.rdm.web.search.searchutils.reportError(
                  // TODO Make this a different error message that includes the resourceURI context?
                  dojo.string.substitute(messages.errorAttemptingToRetrieveDocTypeInfo,
                      { error: (error.description || error) })
            );
        },

        /**
         * It's not necessarily the case that there's an index rule pertaining
         * to every field mentioned in within a particular doctype.  It's also
         * not the necessarily the case that there's there exists an index rule
         * for a particular doctype.  This function is called to prune the
         * this._attributeValueData appropriately (i.e. remove appropriate
         * field elements within a property's array value or remove appropriate
         * properties).
         */
        _requestIndexRuleContents: function(indexRuleNamespace) {
            com.ibm.rdm.web.search.searchutils.showAsBusy(true);
        },

        _handleGetIndexRuleSuccessResponse: function(response) {
            com.ibm.rdm.web.search.searchutils.showAsBusy(false);
            var parser = new com.ibm.rdm.web.search.IndexRuleParser({doc:response});
            var indexedFieldNamesObject = parser.getIndexedFieldNamesObject();
            var namespace = parser.getNamespace();
            var nsShortName = namespace.substring(namespace.lastIndexOf("/")+1);
            var origProps = this._attributeValueData[nsShortName];
            var filteredProps = dojo.filter(
                origProps,
                function(item) {
                    var attributeName = item.attributeName;
                    return (indexedFieldNamesObject[attributeName] != undefined);
                }
            );
            if (filteredProps.length == 0) {
//                 this._removeDocType(namespace);
                this._attributeValueData[nsShortName] = filteredProps;
            } else {
                this._attributeValueData[nsShortName] = filteredProps;
            }
            this._maybeUpdateAdvancedQuerySection();
        },

        _handleGetIndexRuleErrorResponse: function(ioArgs, error) {
            com.ibm.rdm.web.search.searchutils.showAsBusy(false);
            // Note: It may be the case that there exist doctypes that are not currently
            // "active" (in that they aren't associated with an indexing rule).
            // Since this is expected we'll just log an error for this case ... but if
            // it's any other kind of error we'll use reportError ...
            if (ioArgs.xhr.status == 404) {
                var url = ioArgs.args.url;
                var lastSegment = url.substring(url.lastIndexOf("/")+1);
                var doctypeNamespace = lastSegment.replace("___", "://");
                console.error(
                    "Could not find index rule for doctype namespace '"
                    + doctypeNamespace
                    + "' due to the fact that attempting to GET '"
                    + url
                    + "' leads to File Not Found"
                );
                this._removeDocType(doctypeNamespace);
            } else {
                var messages = this._getMessages();
                com.ibm.rdm.web.search.searchutils.reportError(
                      // TODO Make this a different error message that includes the resourceURI context?
                      dojo.string.substitute(messages.errorAttemptingToRetrieveDocTypeInfo,
                          { error: (error.description || error) })
                );
            }
            this._maybeUpdateAdvancedQuerySection();
        },

        _removeDocType: function(doctypeNamespace) {
            var filteredDoctypeNamespaces = dojo.filter(
                this._doctypeNamespaces,
                function(item) {
                    return (! (item == doctypeNamespace));
                }
            );
            this._doctypeNamespaces = filteredDoctypeNamespaces;
        },

        _maybeUpdateAdvancedQuerySection: function() {
            if (!com.ibm.rdm.web.search.searchutils.isBusy()) {
                this.searchQuery.doctypeInfoHasBeenUpdated();
            }
        }
    }
);

})();
