/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.search.IndexRuleParser");


dojo.declare(
    "com.ibm.rdm.web.search.IndexRuleParser",
    null,
    {
        ///////////////////////////////////////////////////////////////////////////////////
        // Private fields

        _fieldNamesObject: null,
        _namespace: null,

        ///////////////////////////////////////////////////////////////////////////////////
        // API

        /**
         * keywordParameters.doc ... a DocType XSD document
         */
	    constructor: function(/* Object */ keywordParameters) {
            this._fieldNamesObject = new Object;
            this._parseXSD(keywordParameters.doc);
        },

        /**
         * The properties associated with the returned object will correspond to all field
         * names associated with this index rule.
         */
        getIndexedFieldNamesObject: function() {
            return this._fieldNamesObject;
        },

        getNamespace: function() {
            return this._namespace;
        },

        ///////////////////////////////////////////////////////////////////////////////////
        // Helpers

        _parseXSD: function(doc) {
            var indexNodes = doc.getElementsByTagName("index");
            for (var i = 0; i < indexNodes.length; i++) {
                var indexNode = indexNodes[i];
                var fieldName = indexNode.getAttribute("element");
                this._fieldNamesObject[fieldName] = true;
            }
            this._namespace = this._getNamespace(doc);
        },

        _getNamespace: function(doc) {
            var node = doc.getElementsByTagName("indexSpecification")[0];
            return node.getAttribute("namespace");
        }
    }
);

})();
