/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.search.results.SecondaryResourceEntriesTracker");

dojo.require("com.ibm.rdm.web.search.searchutils");


dojo.declare(
    "com.ibm.rdm.web.search.results.SecondaryResourceEntriesTracker",
    null,
    {
        /**
         * An object whose properties represent the parent resource names for
         * all tracked secondary resources.
         */
        _trackedParentResourceURIsObject: null,
        /**
         * An object whose properties represent the resource names for all
         * tracked secondary resources.
         */
        _trackedSecondaryResourceURIsObject: null,

	    constructor: function() {
            this._trackedParentResourceURIsObject = new Object;
            this._trackedSecondaryResourceURIsObject = new Object;
        },

        /**
         * Note: This function assumes that resourceURI represents a secondary resource.
         */
        isParentResourceAlreadyTracked: function(resourceURI) {
            var parentResourceURI = com.ibm.rdm.web.search.searchutils.getSecondaryResourceParentURI(resourceURI);
            return (this._trackedParentResourceURIsObject[parentResourceURI]);
        },

        trackSecondaryResource: function(resourceURI) {
            var parentResourceURI = com.ibm.rdm.web.search.searchutils.getSecondaryResourceParentURI(resourceURI);
            this._trackedParentResourceURIsObject[parentResourceURI] = true;
            this._trackedSecondaryResourceURIsObject[resourceURI] = true;
        },

        getMatchedSecondaryResourceURIsObject: function() {
            return this._trackedSecondaryResourceURIsObject;
        }
    }
);

})();
