/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2008, 2009.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.search.results.TimeWindowSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rdm.web.common.CollapseableTitleSection");
// dojo.requireLocalization("com.ibm.rdm.web.search.results", "TimeWindowSection");


/**
 * Displays a time-based twisty section.  Within this section are resources
 * which are shown when the section is expanded, and hidden when the section
 * is collapsed.
 */
dojo.declare(
    "com.ibm.rdm.web.search.results.TimeWindowSection",
    [dijit._Widget, dijit._Templated, com.ibm.rdm.web.common.CollapseableTitleSection],
    {
        ///////////////////////////////////////////////////////////////////////////////////
        // Attach points

        _image: null,
        _titleSpan: null,
        _resourcesTable: null,

        ///////////////////////////////////////////////////////////////////////////////////
        // Public fields

        //sectionTitle: null,
        recentResourceResults: null,

        ///////////////////////////////////////////////////////////////////////////////////
        // Private fields

//         _messages: null,
        _resourceInfos: null,
        _tbody: null,
        _collapseableHeader: null,

        ///////////////////////////////////////////////////////////////////////////////////
        // API

        postCreate: function() {
//             this._messages = dojo.i18n.getLocalization("com.ibm.rdm.web.search.results", "TimeWindowSection", this.lang);
            //this._titleSpan.appendChild(document.createTextNode(this.sectionTitle));
            //this._collapseableHeader = new com.ibm.rdm.web.common.CollapseableTitleSection({
            //	sectionTitle:this.sectionTitle
            //},this._titleSpan);
    		this.inherited("postCreate", arguments);
            var table = document.createElement("table");
            table.setAttribute("width", "100%");
            this._resourcesTable = table;
            var tbody = document.createElement("tbody");
            this._resourcesTable.appendChild(tbody);
            this._tbody = tbody;
            this._resourceInfos = [];
            this.isOpen = false;
            this.setContent(this._resourcesTable);
            //this._image.setAttribute("src", this._getImageSrc(this.isOpen));
            //this.connect(this._image, "onclick", this._handleImageClicked);
        },
        
        startup: function() {
        	this.inherited("startup", arguments);
        },

        destroy: function() {
        	this.inherited(arguments);
        },
        
        addResourceInfo: function(resourceInfo) {
            this._resourceInfos.push(resourceInfo);
        },

        getTallyOfResourcesThatWouldBeHiddenViaFilters: function() {
            var numThatWouldBeHidden = 0;
            for (var i = 0; i < this._resourceInfos.length; i++) {
                var resourceInfo = this._resourceInfos[i];
                if (!this.recentResourceResults.shouldResourceBeVisible(resourceInfo)) {
                    numThatWouldBeHidden++;
                }
            }
            return numThatWouldBeHidden;
        },

        getNumberOfResources: function() {
            return this._resourceInfos.length;
        },

        shouldBeShown: function() {
            return (
                this.getTallyOfResourcesThatWouldBeHiddenViaFilters()
                != this.getNumberOfResources()
            );
        },

        setExpanded: function() {
        	this._showResources();
        	this._expand();
        	//dojo.addClass(this._collapseableHeader, "expanded");
            /*if (!this.isOpen) {
            	this._handleImageClicked();
            }*/
        },

        setCollapsed: function() {
        	this._showResources();
        	this._collapse();
        	//this._hideResources();
        	//dojo.addClass(this._collapseableHeader, "collapsed");
            /*if (this.isOpen) {
                this._handleImageClicked();
            }*/
        },

        ///////////////////////////////////////////////////////////////////////////////////
        // Helpers
        _showResources: function() {
            if (!this._tbody.firstChild) {
                // Note: We defer creating the rows until the first time the section
                // is explicitly expanded.
                for (var i = 0; i < this._resourceInfos.length; i++) {
                    var resourceInfo = this._resourceInfos[i];
                    this.recentResourceResults.createAndAppendResourceTableRow(resourceInfo, this._tbody);
                }
            }
            // TODO Look into using dojo.fx.wipeIn
            this._resourcesTable.style.display = "";
        }

/*        _hideResources: function() {
            // TODO Look into using dojo.fx.wipeOut
            this._resourcesTable.style.display = "none";
        }*/
    }
);

})();
