 /* Copyright IBM Corp. 2007, 2009.  All Rights Reserved.
  *
  * US Government Users Restricted Rights - Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
  */
(function() {
dojo.provide("com.ibm.rdm.web.server.XhrUtils");

com.ibm.rdm.web.server.XhrUtils = {
	
    ///////////////////////////////////////////////////////////////////////////////////
    // API
	
	getResponseEtag: function(response, doNotStripQuotes) {
        var etag = null;
    	try {
        	etag = response.ioArgs.xhr.getResponseHeader("Etag");
        	if(!doNotStripQuotes) {
	        	if (etag && etag.indexOf('"') == 0) {
	        		etag = etag.substring(1, etag.length-1);
	        	}
        	}
    	}
    	catch(e) {
    		console.error(e);
    	}
    	return etag;
    },
    
    getResponseCode: function(response) {
    	var responseCode = null;
    	try {
        	responseCode = response.ioArgs.xhr.status;
    	}
    	catch(e) {
    		console.error(e);
    	}
    	return responseCode;
    },
    
	getResponseURI: function(response) {
        var uri = null;
    	try {
        	uri = response.ioArgs.args.url;
    	}
    	catch(e) {
    		console.error(e);
    	}
    	return uri;       
    },
    
    getHeader: function(response, header) {
        var headerValue = null;
    	try {
        	headerValue = response.ioArgs.xhr.getResponseHeader(header);
    	}
    	catch(e) {
    		console.error(e);
    	}
    	return headerValue;
    }
};

})();
