/*
 * Copyright (c) 2007, 2009. IBM Corporation
 * All rights reserved.
 */
dojo.provide("com.ibm.rdm.web.util.autoscroller");


/**
 * Place to put utils during early development. Like all files named util,
 * this will soon get large and unmanagable. Please refactor as needed.<br> 
*/
com.ibm.rdm.web.util.autoscroller = {
	scrollToNode: function(targetNode, scrollableContainerNode) {
		//this method determines the boundaries of the target node and scrollable container
		
		var targetNodeCoords = dojo.coords(targetNode, true);
		var scrollableContainerNodeCoords = dojo.coords(scrollableContainerNode, true);
		var scrollableContainerScrollTop = scrollableContainerNode.scrollTop;
		
		var scrollY1 = scrollableContainerNode.scrollTop;
		var scrollY2 = scrollableContainerNode.scrollTop + scrollableContainerNodeCoords.h;
		if (scrollY2 > scrollableContainerNode.scrollHeight)
			scrollY2 = scrollableContainerNode.scrollHeight;
			
		var targetY1 = dojo.isIE?
								targetNodeCoords.t:
								targetNodeCoords.t - scrollableContainerNodeCoords.t;
		var targetNodeParent = targetNode.parentNode;

		//we must loop through all parent nodes in order to obtain correct measurement
		if (targetNode != scrollableContainerNode) {
			while (scrollableContainerNode != targetNodeParent) {
				if (targetNodeParent.style.top) {
					targetY1 += dojo.coords(targetNodeParent, true).t;
				}
				targetNodeParent = targetNodeParent.parentNode;
			}
		}
		var targetY2 = targetY1 + targetNodeCoords.h;
		//if (targetY1 < scrollY1 || targetY1 > scrollY2) {
			if(targetY1 < scrollY1) {
				scrollToY = targetY1;
			}
			else {
				if (targetNodeCoords.h > scrollableContainerNodeCoords.h) {
					scrollToY = targetY1;
				}
				else {
					scrollToY = targetY2-scrollableContainerNodeCoords.h;
				}
			}
			var anim = new dojo._Animation({
				curve: [scrollableContainerNode.scrollTop, scrollToY],
				duration: 300
			});
			
			dojo.connect(anim, "onAnimate", this, function (offset) {
				scrollableContainerNode.scrollTop = offset;
			});
			
			anim.play();
		//}
		
		
		

		var scrollX1 = scrollableContainerNode.scrollLeft;
		var scrollX2 = scrollableContainerNode.scrollLeft + scrollableContainerNodeCoords.w;
		if (scrollX2 > scrollableContainerNode.scrollWidth)
			scrollX2 = scrollableContainerNode.scrollWidth;
			
		var targetX1 = targetNodeCoords.l;
		var targetNodeParent = targetNode.parentNode;

		//we must loop through all parent nodes in order to obtain correct measurement
		if (targetNode != scrollableContainerNode) {
			while (scrollableContainerNode != targetNodeParent) {
				if (targetNodeParent.style.top) {
					targetX1 += dojo.coords(targetNodeParent, true).l;
				}
				targetNodeParent = targetNodeParent.parentNode;
			}
		}
		
		var targetX2 = targetX1 + targetNodeCoords.w;
		
		//if (targetX1 < scrollX1 || targetX1 > scrollX2) {
			
			if(targetX1 < scrollX1) {
				scrollToX = targetX1;
			}
			else {
				if (targetNodeCoords.w > scrollableContainerNodeCoords.w) {
					scrollToX = targetY1;
				}
				else {
					scrollToX = targetX2-scrollableContainerNodeCoords.w;
				}
			}
			
			var anim = new dojo._Animation({
				curve: [scrollableContainerNode.scrollLeft, scrollToX],
				duration: 300
			});
			
			dojo.connect(anim, "onAnimate", this, function (offset) {
				scrollableContainerNode.scrollLeft = offset;
			});
			
			anim.play();
		//}
	 
	 }
};
