/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rdm.web.viewlet.MyReviews");

dojo.require("com.ibm.rdm.web.review.ReviewsViewer");
dojo.require("com.ibm.rdm.web.common.UpdateContext");
dojo.require("com.ibm.rdm.web.viewlet.RRCViewlet");

(function() {

var RRCViewlet = com.ibm.rdm.web.viewlet.RRCViewlet;

dojo.declare("com.ibm.rdm.web.viewlet.MyReviews",
	RRCViewlet, {
	
	templatePath: dojo.moduleUrl("com.ibm.rdm.web", "viewlet/templates/MyReviews.html"),
	_myReviewsSectionNode: null,
	_myReviewsSection: null,
	// context as ReviewsViewer is also used by Project Dashboard
	_myReviewsViewlet: true,

	postCreate: function() {
		//this.getSite().setLoading(true);
		this._myReviewsSection = new com.ibm.rdm.web.review.ReviewsViewer({
			myReviewsViewlet: this._myReviewsViewlet,
            _viewlet: this,
			site: this.getSite()
		}, this._myReviewsSectionNode);
	},
	   
	destroy: function() {
 		this._myReviewsSection.destroyRecursive();
        this.inherited(arguments);
    },
	
	refresh: function() {
		this.inherited(arguments);
		if (this.isInitialized()) {
			com.ibm.rdm.web.common.UpdateContext.refreshHasOccurred();
			this._myReviewsSection.startup();
		}
		else {
			this.waitForInit(dojo.hitch(this, this.refresh));
		}
	}
	
});

})();
