/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rdm.web.viewlet.RecentArtifacts");

dojo.require("dojo.i18n");

dojo.require("com.ibm.rdm.web.common.UpdateContext");
dojo.require("com.ibm.rdm.web.search.results.RecentResourceResults");
dojo.require("com.ibm.rdm.web.viewlet.RRCViewlet");

(function() {

var RRCViewlet = com.ibm.rdm.web.viewlet.RRCViewlet;

dojo.declare("com.ibm.rdm.web.viewlet.RecentArtifacts",
	RRCViewlet, {
	
	templatePath: dojo.moduleUrl("com.ibm.rdm.web", "viewlet/templates/RecentArtifacts.html"),

	postCreate: function() {
		//this.getSite().setLoading(false);
		
		this._messages = dojo.i18n.getLocalization("com.ibm.rdm.web.common", "common");
		
		this._recentArtifacts = new com.ibm.rdm.web.search.results.RecentResourceResults({
            viewType:com.ibm.rdm.web.search.results.RecentResourceResults.viewTypes.SHOW_ARTIFACTS,
            displayContext:com.ibm.rdm.web.search.results.RecentResourceResults.displayContext.USER_DASHBOARD,
            headerTitle: this._messages.artifactsLoading,          
            _viewlet: this
        }, this._recentlyModifiedSectionNode);			
	},
	   
	destroy: function() {
 		this._recentArtifacts.destroyRecursive();
        this.inherited(arguments);
    },
	
	refresh: function() {
		this.inherited(arguments);
		if (this.isInitialized()) {
			com.ibm.rdm.web.common.UpdateContext.refreshHasOccurred();
			this._recentArtifacts.startup();
		}
		else {
			this.waitForInit(dojo.hitch(this, this.refresh));
		}
	}

});

})();
